// coding: utf-8
/** Created by: Udo Schmal | https://www.gocher.me/ */
(function () {
  'use strict';
  function Tree(tree){
    function toggle(event) {
      var el = this;
      if (el.className == 'nextPlus') {
        el.className = 'nextMinus';
      } else if (el.className == 'nextMinus') {
        el.className = 'nextPlus';
      } else if (el.className == 'lastPlus') {
        el.className = 'lastMinus';
      } else if (el.className == 'lastMinus') {
        el.className = 'lastPlus';
      };
      var branch = el.parentNode.getElementsByTagName('ul')[0];
      branch.className = (branch.className == '') ? 'visible' : '';
      event.stopPropagation();
    }
    function init(tree, ebenen) {
      if (!ebenen) {
        ebenen = [];
      };
      var liNodes = tree.children;
      for (var i=0, len=liNodes.length; i < len; i++) {
        var el = document.createElement("span");
        if (liNodes[i].getElementsByTagName('ul').length > 0) {
          el.className = (i==liNodes.length-1) ? "lastPlus" : "nextPlus";
          el.addEventListener('click', toggle);
          ebenen.push((i==liNodes.length-1) ? 'blank' : 'cont');
          init(liNodes[i].getElementsByTagName('ul')[0], ebenen);
          ebenen.pop();
        } else {
          el.className = (i==liNodes.length-1) ? "last" : "next";
        };
        liNodes[i].insertBefore(el, liNodes[i].firstChild);
        for (var a=ebenen.length-1; a>=0; a--) {
          var el = document.createElement("span");
          el.className = ebenen[a];
          liNodes[i].insertBefore(el, liNodes[i].firstChild);
        }
      }
    }
    init(tree);
  }

  var treeList = document.querySelectorAll("ul.tree");
  if (treeList.length > 0) {
    if (!document.getElementById('treeview.css')) {
      var style = document.createElement("link");
      style.type = 'text/css';
      style.addEventListener('load', function () {
        init();
      });
      style.href = '/code/treeview/treeview.css';
      style.id = 'treeview.css';
      style.rel = 'stylesheet';
      document.head.appendChild(style);
    } else {
      init();
    }
    function init() {
      for (var i=0; i<treeList.length; i++) {
        new Tree(treeList[i]);
      }
    }
  }
})();
